VERSION 4.00
Begin VB.Form amqsailqFrm 
   Caption         =   "MQSeries MQAI Sample"
   ClientHeight    =   5775
   ClientLeft      =   2940
   ClientTop       =   1950
   ClientWidth     =   6750
   Height          =   6180
   Icon            =   "amqsailq.frx":0000
   Left            =   2880
   LinkTopic       =   "Form1"
   ScaleHeight     =   5775
   ScaleWidth      =   6750
   Top             =   1605
   Width           =   6870
   Begin VB.CommandButton HelpButton 
      Caption         =   "&Help"
      Height          =   375
      Left            =   1200
      TabIndex        =   10
      Top             =   5280
      Width           =   1215
   End
   Begin VB.Frame QFrame 
      Caption         =   "Queues"
      DragMode        =   1  'Automatic
      Height          =   3375
      Left            =   120
      TabIndex        =   7
      Top             =   1680
      Width           =   6495
      Begin VB.CommandButton clearButton 
         Caption         =   "&Clear"
         Height          =   375
         Left            =   5040
         TabIndex        =   9
         Top             =   2880
         Width           =   1215
      End
      Begin VB.ListBox QSLBox 
         BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
            Name            =   "Fixedsys"
            Size            =   9
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   2310
         Left            =   240
         TabIndex        =   8
         Top             =   360
         Width           =   6015
      End
   End
   Begin VB.Frame QMgrFrame 
      Caption         =   "Queue Manager"
      Height          =   1455
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   6495
      Begin VB.TextBox QMgrTBox 
         Height          =   375
         Left            =   1440
         TabIndex        =   5
         Top             =   360
         Width           =   4935
      End
      Begin VB.CommandButton qInfoButton 
         Caption         =   "&Display Queue Info"
         Height          =   375
         Left            =   4200
         TabIndex        =   4
         Top             =   960
         Width           =   2175
      End
      Begin VB.Label Label1 
         Alignment       =   1  'Right Justify
         Caption         =   "Queue Manager Name "
         Height          =   375
         Left            =   120
         TabIndex        =   6
         Top             =   360
         Width           =   1215
      End
   End
   Begin VB.PictureBox Picture1 
      Appearance      =   0  'Flat
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   480
      Left            =   6000
      Picture         =   "amqsailq.frx":030A
      ScaleHeight     =   480
      ScaleWidth      =   480
      TabIndex        =   2
      Top             =   5160
      Width           =   480
   End
   Begin VB.CommandButton aboutButton 
      Caption         =   "&About"
      Height          =   375
      Left            =   2640
      TabIndex        =   1
      Top             =   5280
      Width           =   1335
   End
   Begin VB.CommandButton quitButton 
      Caption         =   "E&xit"
      Height          =   375
      Left            =   4320
      TabIndex        =   0
      Top             =   5280
      Width           =   1215
   End
End
Attribute VB_Name = "amqsailqFrm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False


'******************************************************************************'
'*                                                                            *'
'* Program name: AMQSAILQ.VBP                                                 *'
'*                                                                            *'
'* Description:  Sample Visual Basic program to inquire the current depth of  *'
'*               the local queues using the MQSeries Administration Interface *'
'*               (MQAI).                                                      *'
'*                                                                            *'
'* Statement:    Licensed Materials - Property of IBM                         *'
'*                                                                            *'
'*               84H2004, 5639-B43                                            *'
'*                                                                            *'
'*               (C) Copyright IBM Corp. 1998                                 *'
'*                                                                            *'
'******************************************************************************'
'*                                                                            *'
'* Function:                                                                  *'
'*    AMQSAILQ is a sample Visual Basic program that demonstrates how to      *'
'*    inquire attributes of the local Queue Manager using the MQAI interface, *'
'*    in particular it inquires the current depths of all the local queues.   *'
'*                                                                            *'
'*     - A PCF command is built from items placed into an MQAI bag.           *'
'*       These are:-                                                          *'
'*            - The generic queue name "*"                                    *'
'*            - The type required which in this case is local.                *'
'*                                                                            *'
'*     - The mqExecute call is executed with the command MQCMD_INQUIRE_Q.     *'
'*       This command inquires all the attributes of all the local queues.    *'
'*       The call will generate the correct PCF structure.                    *'
'*       The default options to the call are used so that the command is sent *'
'*       to the SYSTEM.ADMIN.COMMAND.QUEUE.                                   *'
'*       The reply from the command server is placed on a temporary dynamic   *'
'*       queue.                                                               *'
'*       The reply from the MQCMD_INQUIRE_Q command is read from the          *'
'*       temporary queue and formatted into the response bag.                 *'
'*                                                                            *'
'*     - The completion code from the mqExecute call is checked and if there  *'
'*       is a failure from the command server then the code returned by the   *'
'*       command server is retrieved from the system bag that has been        *'
'*       embedded in the response bag to the mqExecute call.                  *'
'*                                                                            *'
'*     - If the call is successful then the attributes of each local queue    *'
'*       have been placed in system bags embedded in the response bag of the  *'
'*       mqExecute call.                                                      *'
'*       The name and depth of each queue is obtained from each of the bags   *'
'*       and the result displayed on the screen.                              *'
'*                                                                            *'
'* Note: The command server must be running.                                  *'
'*                                                                            *'
'******************************************************************************'

Dim Hconn As Long                    ' Handle to MQ connection

Private Sub aboutButton_Click()
  aboutDialog.Show
End Sub

Private Sub clearButton_Click()
  ' Clear List Box
  QSLBox.Clear
End Sub

Private Sub Form_Load()
  '******************************************************************************'
  '* Set up defaults                                                            *'
  '******************************************************************************'
  MQ_SETDEFAULTS
  aboutDialog.mqInfoTBox.Text = "MQSeries Visual Basic Sample" & Chr(13) & Chr(10) & "Using the MQAI to inquire attributes"
End Sub

Private Sub HelpButton_Click()
  Me.Enabled = False
  amqsailqHelpFrm.Show
End Sub

Private Sub qInfoButton_Click()

   Const VBQMNameLength = MQ_Q_MGR_NAME_LENGTH + 1
   Const VBQNameLength = MQ_Q_NAME_LENGTH + 1

   Dim QMName As String * VBQMNameLength  ' Default queue manager name
   Dim Reason As Long                     ' Reason code
   Dim ConnReason As Long                 ' MQCONN reason code
   Dim CompCode As Long                   ' Completion code
   Dim CommandBag As Long                 ' Command bag for mqExecute
   Dim ResponseBag As Long                ' Response bag for mqExecute
   Dim QAttrsBag As Long                  ' Bag containing queue attributes
   Dim ErrorBag As Long                   ' Bag containing command server error
   Dim mqExecuteCC As Long                ' mqExecute completion code
   Dim mqExecuteRC As Long                ' mqExecute reason code
   Dim QNameLength As Long                ' Actual length of queue name
   Dim QDepth As Long                     ' Depth of queue
   Dim I As Long                          ' Loop counter
   Dim NumberOfBags As Long               ' Number of bags in response bag
   Dim qname As String * VBQNameLength    ' Name of queue extracted from bag

   CommandBag = MQHB_UNUSABLE_HBAG
   ResponseBag = MQHB_UNUSABLE_HBAG

   '***************************************************************************'
   '* Connect to the queue manager                                            *'
   '***************************************************************************'
   QMName = QMgrTBox.Text
   If QMName = "" Then QMName = " "
   MQCONN QMName, Hconn, CompCode, ConnReason

   '***************************************************************************'
   '* Report the reason and stop if the connection failed.                    *'
   '***************************************************************************'
   If CompCode = MQCC_FAILED Then
     If ConnReason = MQRC_Q_MGR_NAME_ERROR Then
       DisplayError "The specified queue manager does not exist"
     Else
       DisplayError "MQCONN failed with code " & ConnReason
       End
     End If
   End If

   '***************************************************************************'
   '* Create a command bag for the mqExecute call                             *'
   '***************************************************************************'
   If ConnReason = MQRC_NONE Then
     mqCreateBag MQCBO_ADMIN_BAG, CommandBag, CompCode, Reason
     If CompCode <> MQCC_OK Then
       DisplayError "mqCreateBag failed with code " & Reason
       quitButton_Click
     End If
  
     '***************************************************************************'
     '* Create a response bag for the mqExecute call                            *'
     '***************************************************************************'
     mqCreateBag MQCBO_ADMIN_BAG, ResponseBag, CompCode, Reason
     If CompCode <> MQCC_OK Then
       DisplayError "mqCreateBag failed with code " & Reason
       quitButton_Click
     End If
  
     '***************************************************************************'
     '* Put the generic queue name into the command bag                         *'
     '***************************************************************************'
     mqAddString CommandBag, MQCA_Q_NAME, MQBL_NULL_TERMINATED, "*", CompCode, Reason
     If CompCode <> MQCC_OK Then
       DisplayError "mqAddString failed with code " & Reason
       quitButton_Click
     End If
  
     '***************************************************************************'
     '* Put the local queue type into the command bag                           *'
     '***************************************************************************'
     mqAddInteger CommandBag, MQIA_Q_TYPE, MQQT_LOCAL, CompCode, Reason
     If CompCode <> MQCC_OK Then
       DisplayError "mqAddInteger failed with code " & Reason
       quitButton_Click
     End If
  
     '***************************************************************************'
     '* Add an inquiry for current queue depths                                 *'
     '***************************************************************************'
     mqAddInquiry CommandBag, MQIA_CURRENT_Q_DEPTH, CompCode, Reason
     If CompCode <> MQCC_OK Then
       DisplayError "mqAddInquiry failed with code " & Reason
       quitButton_Click
     End If
  
     '***************************************************************************'
     '* Send the command to find all the local queue names and attributes.      *'
     '* The mqExecute call will create the PCF structure required, send it to   *'
     '* the command server and receive the reply from the command server into   *'
     '* the response bag. The attributes will be contained in system bags       *'
     '* embedded into the response bag, one set of attributes per bag.          *'
     '***************************************************************************'
     mqExecute Hconn, 13, MQHB_NONE, CommandBag, ResponseBag, MQHO_NONE, MQHO_NONE, CompCode, Reason
  
     If Reason = MQRC_CMD_SERVER_NOT_AVAILABLE Then
        MsgBox "The command server is not running" & Chr(13) & Chr(10) & "Please start it with the command: strmqcsv QMgrName", vbOKOnly + vbInformation, "Information"
     Else
  
       '****************************************************************************'
       '* Check the result from mqExecute call, if successful find the current     *'
       '* depths of all the local queues, find the error if it failed              *'
       '****************************************************************************'
       If CompCode = MQCC_OK Then
         '**************************************************************************'
         '* Count the number of system bags embedded in the response bag from the  *'
         '* mqExecute call. The attributes for each queue are in a separate bag.   *'
         '**************************************************************************'
         mqCountItems ResponseBag, MQHA_BAG_HANDLE, NumberOfBags, CompCode, Reason
         If CompCode <> MQCC_OK Then
           DisplayError "mqCountItems failed with code " & Reason
           quitButton_Click
         End If
    
         For I = 0 To (NumberOfBags - 1)
           '************************************************************************'
           '* Get the next system bag handle out of the mqexecute response bag.    *'
           '* This bag contains the queue attributes                               *'
           '************************************************************************'
           mqInquireBag ResponseBag, MQHA_BAG_HANDLE, I, QAttrsBag, CompCode, Reason
           If CompCode <> MQCC_OK Then
             DisplayError "mqInquireBag(" & I & ") failed with code " & Reason
             quitButton_Click
           End If
    
           '************************************************************************'
           '* Get the queue name out of the queue attributes bag                   *'
           '************************************************************************'
           mqInquireString QAttrsBag, MQCA_Q_NAME, 0, MQ_Q_NAME_LENGTH, qname, QNameLength, 0, CompCode, Reason
           If CompCode <> MQCC_OK Then
             DisplayError "mqInquireString failed with code " & Reason
             quitButton_Click
           End If
    
           '************************************************************************'
           '* Get the depth out of the queue attributes bag                        *'
           '************************************************************************'
           mqInquireInteger QAttrsBag, MQIA_CURRENT_Q_DEPTH, MQIND_NONE, QDepth, CompCode, Reason
           If CompCode <> MQCC_OK Then
              DisplayError "mqInquireInteger failed with code " & Reason
              quitButton_Click
           End If
    
           '************************************************************************'
           '* Print the result                                                     *'
           '************************************************************************'
           QSLBox.AddItem QDepth & String(5, " ") & qname
         Next I
         QSLBox.AddItem String(60, "-")
    
       Else                                               '* Failed mqExecute      *'
    
         DisplayError "Call to get queue attributes failed" & Chr(13) & Chr(10) & "Completion Code =  " & CompCode & Chr(13) & Chr(10) & "Reason = " & Reason
         If Reason = MQRCCF_COMMAND_FAILED Then
           '************************************************************************'
           '* Get the system bag handle out of the mqexecute response bag.         *'
           '* This bag contains the reason from the command server why the         *'
           '* command failed.                                                      *'
           '************************************************************************'
           mqInquireBag ResponseBag, MQHA_BAG_HANDLE, I, ErrorBag, CompCode, Reason
           If CompCode <> MQCC_OK Then
             DisplayError "mqInquireBag failed with code " & Reason
             quitButton_Click
           End If
    
           '************************************************************************'
           '* Get the completion code and reason code, returned by the command     *'
           '* server, from the embedded error bag.                                 *'
           '************************************************************************'
           mqInquireInteger ErrorBag, MQIASY_COMP_CODE, MQIND_NONE, mqExecuteCC, CompCode, Reason
           If CompCode <> MQCC_OK Then
             DisplayError "mqInquireInteger failed with code " & Reason
             quitButton_Click
           End If
           mqInquireInteger ErrorBag, MQIASY_REASON, MQIND_NONE, mqExecuteRC, CompCode, Reason
           If CompCode <> MQCC_OK Then
             DisplayError "mqInquireBag failed with code " & Reason
             quitButton_Click
           End If
         End If
       End If
     End If
  
     '***************************************************************************'
     '* Delete the command bag if successfully created.                         *'
     '***************************************************************************'
     If CommandBag <> MQHB_UNUSABLE_HBAG Then mqDeleteBag CommandBag, CompCode, Reason
     If CompCode <> MQCC_OK Then
       DisplayError "mqDeleteBag failed with code " & Reason
       quitButton_Click
     End If
  
     '***************************************************************************'
     '* Delete the response bag if successfully created.                        *'
     '***************************************************************************'
     If ResponseBag <> MQHB_UNUSABLE_HBAG Then mqDeleteBag ResponseBag, CompCode, Reason
     If CompCode <> MQCC_OK Then
       DisplayError "mqDeleteBag failed with code " & Reason
       quitButton_Click
     End If
  
     '***************************************************************************'
     '* Disconnect from the queue manager if not already connected              *'
     '***************************************************************************'
     If ConnReason <> MQRC_ALREADY_CONNECTED Then MQDISC Hconn, CompCode, Reason
     If CompCode <> MQCC_OK Then
       DisplayError "mqDeleteBag failed with code " & Reason
       quitButton_Click
     End If
  End If
End Sub

Private Sub quitButton_Click()
  Dim CompCode As Long, Reason As Long
  If Hconn <> 0 Then MQDISC Hconn, CompCode, Reason
  End
End Sub

Sub DisplayError(ByVal Message As String)

  ' Displays an error message in a message box and beeps
  Beep
  MsgBox Message, vbOKOnly + vbExclamation, "Error"
End Sub
